<?php

/**
 * @copyright Copyright &copy; Kartik Visweswaran, Krajee.com, 2013
 * @package yii2-widgets
 * @version 1.0.0
 */

namespace kartik\widgets;

/**
 * Base asset bundle for all widgets
 *
 * @author Kartik Visweswaran <kartikv2@gmail.com>
 * @since 1.0
 */
class AssetBundle extends \yii\web\AssetBundle
{

	public $depends = [
		'yii\web\JqueryAsset',
		'yii\bootstrap\BootstrapAsset',
	];

	/**
	 * Set up CSS and JS asset arrays based on the base-file names
	 *
	 * @param string $type whether 'css' or 'js'
	 * @param array $files the list of 'css' or 'js' basefile names
	 */
	protected function setupAssets($type, $files = [])
	{
		$srcFiles = [];
		$minFiles = [];
		foreach ($files as $file) {
			$srcFiles[] = "{$file}.{$type}";
			$minFiles[] = "{$file}.min.{$type}";
		}
		if (empty($this->$type)) {
			$this->$type = YII_DEBUG ? $srcFiles : $minFiles;
		}
	}

	/**
	 * Sets the source path if empty
	 *
	 * @param string $path the path to be set
	 */
	protected function setSourcePath($path)
	{
		if (empty($this->sourcePath)) {
			$this->sourcePath = $path;
		}
	}

}