/*!=========================================================================
 *  Bootstrap TouchSpin
 *  v2.6.2
 *
 *  A mobile and touch friendly input spinner component for Bootstrap 3.
 *
 *      https://github.com/istvan-meszaros/bootstrap-touchspin
 *      http://www.virtuosoft.eu/code/bootstrap-touchspin/
 *
 *  Copyright 2013 István Ujj-Mészáros
 *
 * ---------------------------------------------------------
 *  Enhanced by Kartik Visweswaran, 2014, kartikv2@gmail.com
 *
 *  Enabled passing of buttonup and buttondown directly as
 *  HTML content. The buttonup_class & buttondown_class params
 *  have been removed.
 * ---------------------------------------------------------
 *
 *  Thanks for the contributors:
 *      Stefan Bauer - https://github.com/sba
 *      amid2887 - https://github.com/amid2887
 *
 *  Licensed under the Apache License, Version 2.0 (the "License");
 *  you may not use this file except in compliance with the License.
 *  You may obtain a copy of the License at
 *
 *      http://www.apache.org/licenses/LICENSE-2.0
 *
 *  Unless required by applicable law or agreed to in writing, software
 *  distributed under the License is distributed on an "AS IS" BASIS,
 *  WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the License for the specific language governing permissions and
 *  limitations under the License.
 *
 * ====================================================================== */
(function(a){a.fn.TouchSpin=function(b){var c={min:0,max:100,initval:"",step:1,decimals:0,stepinterval:100,forcestepdivisibility:"round",stepintervaldelay:500,prefix:"",postfix:"",prefix_extraclass:"",postfix_extraclass:"",booster:true,boostat:10,maxboostedstep:false,mousewheel:true,buttondown:'<button class="btn btn-default bootstrap-touchspin-down" type="button">-</button>',buttonup:'<button class="btn btn-default bootstrap-touchspin-up" type="button">+</button>'};return this.each(function(){var F,r=a(this),q=r.data(),u,w,y,j,t,k,z,C=0,f=false;D();function D(){if(r.data("alreadyinitialized")){return}r.data("alreadyinitialized",true);if(!r.is("input")){console.log("Must be an input.");return}e();h();p();i();g();E();I();m();w.input.css("display","block")}function h(){if(F.initval!==""&&r.val()===""){r.val(F.initval)}}function v(K){s(K);p();var J=Number(w.input.val());w.input.val(J.toFixed(F.decimals))}function e(){F=a.extend({},c,q,b)}function s(J){F=a.extend({},F,J)}function i(){var K=r.val(),J=r.parent();if(K!==""){K=Number(K).toFixed(F.decimals)}r.data("initvalue",K).val(K);r.addClass("form-control");if(J.hasClass("input-group")){d(J)}else{o()}}function d(K){K.addClass("bootstrap-touchspin");var N=r.prev(),M=r.next();var P,J,L='<span class="input-group-addon bootstrap-touchspin-prefix">'+F.prefix+"</span>",O='<span class="input-group-addon bootstrap-touchspin-postfix">'+F.postfix+"</span>";if(N.hasClass("input-group-btn")){P=F.buttondown,N.append(P)}else{P='<span class="input-group-btn">'+F.buttondown+"</span>";a(P).insertBefore(r)}if(M.hasClass("input-group-btn")){J=F.buttonup,M.prepend(J)}else{J=F.buttonup,J='<span class="input-group-btn">'+F.buttonup+"</span>";a(J).insertAfter(r)}a(L).insertBefore(r);a(O).insertAfter(r);u=K}function o(){var J='<div class="input-group bootstrap-touchspin"><span class="input-group-btn">'+F.buttondown+'</span><span class="input-group-addon bootstrap-touchspin-prefix">'+F.prefix+'</span><span class="input-group-addon bootstrap-touchspin-postfix">'+F.postfix+'</span><span class="input-group-btn">'+F.buttonup+"</span></div>";u=a(J).insertBefore(r);a(".bootstrap-touchspin-prefix",u).after(r);if(r.hasClass("input-sm")){u.addClass("input-group-sm")}else{if(r.hasClass("input-lg")){u.addClass("input-group-lg")}}}function g(){w={down:a(".bootstrap-touchspin-down",u),up:a(".bootstrap-touchspin-up",u),input:a("input",u),prefix:a(".bootstrap-touchspin-prefix",u).addClass(F.prefix_extraclass),postfix:a(".bootstrap-touchspin-postfix",u).addClass(F.postfix_extraclass)}}function E(){if(F.prefix==""){w.prefix.hide()}if(F.postfix==""){w.postfix.hide()}}function I(){r.on("keydown",function(K){var J=K.keyCode||K.which;if(J===38){if(f!=="up"){x();A()}K.preventDefault()}else{if(J===40){if(f!=="down"){G();H()}K.preventDefault()}}});r.on("keyup",function(K){var J=K.keyCode||K.which;if(J===38){l()}else{if(J===40){l()}}});r.on("blur",function(){p()});w.down.on("keydown",function(K){var J=K.keyCode||K.which;if(J===32||J===13){if(f!=="down"){G();H()}K.preventDefault()}});w.down.on("keyup",function(K){var J=K.keyCode||K.which;if(J===32||J===13){l()}});w.up.on("keydown",function(K){var J=K.keyCode||K.which;if(J===32||J===13){if(f!=="up"){x();A()}K.preventDefault()}});w.up.on("keyup",function(K){var J=K.keyCode||K.which;if(J===32||J===13){l()}});w.down.on("mousedown touchstart",function(J){G();H();J.preventDefault();J.stopPropagation()});w.up.on("mousedown touchstart",function(J){x();A();J.preventDefault();J.stopPropagation()});w.up.on("mouseout touchleave touchend touchcancel",function(J){if(!f){return}J.stopPropagation();l()});w.down.on("mouseout touchleave touchend touchcancel",function(J){if(!f){return}J.stopPropagation();l()});w.down.on("mousemove touchmove",function(J){if(!f){return}J.stopPropagation();J.preventDefault()});w.up.on("mousemove touchmove",function(J){if(!f){return}J.stopPropagation();J.preventDefault()});a(document).on("mouseup touchend touchcancel",function(J){if(!f){return}J.preventDefault();l()});a(document).on("mousemove touchmove scroll scrollstart",function(J){if(!f){return}J.preventDefault();l()});if(F.mousewheel){r.on("mousewheel DOMMouseScroll",function(J){var K=J.originalEvent.wheelDelta||-J.originalEvent.detail;J.stopPropagation();J.preventDefault();if(K<0){G()}else{x()}})}}function m(){r.on("touchspin.uponce",function(){l();x()});r.on("touchspin.downonce",function(){l();G()});r.on("touchspin.startupspin",function(J){A()});r.on("touchspin.startdownspin",function(){H()});r.on("touchspin.stopspin",function(){l()});r.on("touchspin.updatesettings",function(J,K){v(K)})}function B(J){switch(F.forcestepdivisibility){case"round":return(Math.round(J/F.step)*F.step).toFixed(F.decimals);break;case"floor":return(Math.floor(J/F.step)*F.step).toFixed(F.decimals);break;case"ceil":return(Math.ceil(J/F.step)*F.step).toFixed(F.decimals);break;default:return J}}function p(){var L,J,K;L=r.val();if(L===""){return}if(F.decimals>0&&L==="."){return}J=parseFloat(L);if(isNaN(J)){J=0}K=J;if(J.toString()!==L){K=J}if(J<F.min){K=F.min}if(J>F.max){K=F.max}K=B(K);if(Number(L).toString()!==K.toString()){r.val(K);r.trigger("change")}}function n(){if(!F.booster){return F.step}else{var J=Math.pow(2,Math.floor(C/F.boostat))*F.step;if(F.maxboostedstep){if(J>F.maxboostedstep){J=F.maxboostedstep;y=Math.round((y/J)*J)}}return Math.max(F.step,J)}}function x(){p();y=parseFloat(w.input.val());if(isNaN(y)){y=0}var K=y,J=n();y=y+J;if(y>F.max){y=F.max;r.trigger("touchspin.on.max");l()}w.input.val(Number(y).toFixed(F.decimals));if(K!==y){r.trigger("change")}}function G(){p();y=parseFloat(w.input.val());if(isNaN(y)){y=0}var K=y,J=n();y=y-J;if(y<F.min){y=F.min;r.trigger("touchspin.on.min");l()}w.input.val(y.toFixed(F.decimals));if(K!==y){r.trigger("change")}}function H(){l();C=0;f="down";r.trigger("touchspin.on.startspin");r.trigger("touchspin.on.startdownspin");k=setTimeout(function(){j=setInterval(function(){C++;G()},F.stepinterval)},F.stepintervaldelay)}function A(){l();C=0;f="up";r.trigger("touchspin.on.startspin");r.trigger("touchspin.on.startupspin");z=setTimeout(function(){t=setInterval(function(){C++;x()},F.stepinterval)},F.stepintervaldelay)}function l(){clearTimeout(k);clearTimeout(z);clearInterval(j);clearInterval(t);switch(f){case"up":r.trigger("touchspin.on.stopupspin");r.trigger("touchspin.on.stopspin");break;case"down":r.trigger("touchspin.on.stopdownspin");r.trigger("touchspin.on.stopspin");break}C=0;f=false}})}})(jQuery);